diff --git a/etc/defaults/rc.conf b/etc/defaults/rc.conf
index b745c40adf..8968922605 100644
--- a/etc/defaults/rc.conf
+++ b/etc/defaults/rc.conf
@@ -198,15 +198,36 @@ dntpd_enable="NO"		# Run dntpd Network Time Protocol (or NO).
 dntpd_program="/usr/sbin/dntpd"	# path to dntpd, if you want a different one.
 dntpd_flags=""			# Flags to dntpd (if enabled) also server name(s)
 
-# Bluetooth deamons and options:
-btconfig_enable="NO"		# Configure Bluetooth devices (or NO).
-btconfig_devices=""		# List of Bluetooth devices (or empty for all).
-#btconfig_<device>=""		# Parameters to pass to <device>.
-btconfig_args=""		# Parameters to pass to all devices.
-sdpd_enable="NO"		# Run the Service Discovery Profile daemon (or NO).
-sdpd_flags=""			# Flags to sdpd (if enabled).
-bthcid_enable="NO"		# Run the Bluetooth Link Key/PIN Code Manager (or NO).
-bthcid_flags=""			# Flags to bthcid (if enabled).
+### Bluetooth ###
+hcsecd_enable="NO"		# Enable hcsecd(8) (or NO)
+hcsecd_config="/etc/bluetooth/hcsecd.conf" # hcsecd(8) configuration file
+
+sdpd_enable="NO"		# Enable sdpd(8) (or NO)
+sdpd_control="/var/run/sdp"	# sdpd(8) control socket
+sdpd_groupname="nobody"		# set spdp(8) user/group to run as after
+sdpd_username="nobody"		# it initializes
+
+bthidd_enable="NO"		# Enable bthidd(8) (or NO)
+bthidd_config="/etc/bluetooth/bthidd.conf" # bthidd(8) configuration file
+bthidd_hids="/var/db/bthidd.hids" # bthidd(8) known HID devices file
+
+rfcomm_pppd_server_enable="NO"	# Enable rfcomm_pppd(8) in server mode (or NO)
+rfcomm_pppd_server_profile="one two"	# Profile to use from /etc/ppp/ppp.conf
+#
+#rfcomm_pppd_server_one_bdaddr=""	# Override local bdaddr for 'one'
+rfcomm_pppd_server_one_channel="1"	# Override local channel for 'one'
+#rfcomm_pppd_server_one_register_sp="NO"	# Override SP and DUN register
+#rfcomm_pppd_server_one_register_dun="NO"	# for 'one'
+#
+#rfcomm_pppd_server_two_bdaddr=""	# Override local bdaddr for 'two'
+rfcomm_pppd_server_two_channel="3"	# Override local channel for 'two'
+#rfcomm_pppd_server_two_register_sp="NO"	# Override SP and DUN register
+#rfcomm_pppd_server_two_register_dun="NO"	# for 'two'
+
+ubthidhci_enable="NO"		# Switch an USB BT controller present on
+#ubthidhci_busnum="3"		# bus 3 and addr 2 from HID mode to HCI mode.
+#ubthidhci_addr="2"		# Check usbconfig list to find the correct
+				# numbers for your system.
 
 # Network Information Services (NIS) options: All need rpcbind_enable="YES" ###
 nis_client_enable="NO"		# We're an NIS client (or NO).
diff --git a/etc/mtree/BSD.include.dist b/etc/mtree/BSD.include.dist
index 38535da037..c28448c8a0 100644
--- a/etc/mtree/BSD.include.dist
+++ b/etc/mtree/BSD.include.dist
@@ -285,8 +285,6 @@
         vlan
         ..
     ..
-    netbt
-    ..
     netgraph
         UI
         ..
@@ -346,6 +344,10 @@
         ..
         async
         ..
+        bluetooth
+            include
+            ..
+        ..
         bpf
         ..
         bridge
diff --git a/etc/rc.d/Makefile b/etc/rc.d/Makefile
index fae9156a18..ac03b8a4ba 100644
--- a/etc/rc.d/Makefile
+++ b/etc/rc.d/Makefile
@@ -7,12 +7,11 @@
 #
 FILES=	DAEMON LOGIN NETWORKING SERVERS \
 	accounting addswap adjkerntz automount automountd autounmountd \
-	bootconf bootparams btconfig bthcid ccd cleanvar cryptdisks \
-	cleartmp cron cryptdisks \
-	devd devfs dhclient dhcp_client dhcpcd diskless dmesg dntpd dumpon \
-	fixbootfile fsck ftpd hostname hotplugd \
-	inetd initdiskless initrandom ip6addrctl ip6fw ipfw ipfw3 \
-	jail keyserv \
+	bluetooth bootconf bootparams bthidd \
+	ccd cleanvar cryptdisks cleartmp cron cryptdisks \
+	devd devfs dhclient dhcp_client dhcpcd diskless dmesg dumpon \
+	fixbootfile fsck ftpd hcsecd hostname hotplugd \
+	inetd initdiskless initrandom ip6fw ipfw ipfw3 jail keyserv \
 	ldconfig local localdaemons lockd lpd lvm \
 	mixer modules motd mountcritlocal mountcritremote mountd mounttmpfs \
 	moused msgs \
@@ -23,7 +22,7 @@ FILES=	DAEMON LOGIN NETWORKING SERVERS \
 	routing rpcbind rtadvd rtsold rwho sysdb savecore sdpd securelevel \
 	sendmail sensorsd serial sppp sshd statd swap1 syscons \
 	sysctl syslogd sysvipcd \
-	ttys udevd udevd_early \
+	ttys ubthidhci udevd udevd_early \
 	varsym vfs_quota vinum virecover vkernel vknetd \
 	watchdogd wpa_supplicant \
 	ypbind yppasswdd ypserv ypset ypupdated ypxfrd
diff --git a/etc/rc.d/bluetooth b/etc/rc.d/bluetooth
new file mode 100644
index 0000000000..e4a57cb4f3
--- /dev/null
+++ b/etc/rc.d/bluetooth
@@ -0,0 +1,365 @@
+#!/bin/sh
+#
+# Copyright (c) 2005 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD: head/etc/rc.d/bluetooth 208060 2010-05-14 04:53:57Z dougb $
+
+# PROVIDE: bluetooth
+# REQUIRE: DAEMON
+# KEYWORD: nojail nostart
+
+. /etc/rc.subr
+
+name="bluetooth"
+rcvar=
+start_cmd="bluetooth_start"
+stop_cmd="bluetooth_stop"
+required_modules="ng_bluetooth ng_hci ng_l2cap ng_btsocket"
+
+##############################################################################
+# Read and parse Bluetooth device configuration file
+##############################################################################
+
+bluetooth_read_conf()
+{
+	local _err _file _line _namespace
+
+	_file=$1
+	_namespace=$2
+	_err=0
+
+	if [ ! -e $_file ]; then
+		return 0
+	fi
+
+	if [ ! -f $_file -o ! -r $_file ]; then
+		err 1 "Bluetooth configuration file $_file is not a file or not readable"
+	fi
+
+	while read _line
+	do
+		case "$_line" in
+		\#*)
+			continue
+			;;
+
+		*)
+			if [ -z "$_line" ]; then
+				continue;
+			fi
+
+
+			if expr "$_line" : "[a-zA-Z0-9_]*=" > /dev/null 2>&1; then
+				eval "${_namespace}${_line}"
+			else
+				warn "Unable to parse line \"$_line\" in $_file"
+				_err=1
+			fi
+			;;
+		esac
+	done < $_file
+
+	return $_err
+}
+
+##############################################################################
+# Setup Bluetooth stack. Create and connect nodes
+##############################################################################
+
+bluetooth_setup_stack()
+{
+	dev=$1
+	shift
+	hook=$1
+	shift
+
+	# Setup HCI
+	ngctl mkpeer ${dev}: hci ${hook} drv \
+		> /dev/null 2>&1 || return 1
+
+	ngctl name ${dev}:${hook} ${dev}hci \
+		> /dev/null 2>&1 || return 1
+
+	ngctl msg ${dev}hci: set_debug ${bluetooth_device_hci_debug_level} \
+		> /dev/null 2>&1 || return 1
+
+	# Setup L2CAP
+	ngctl mkpeer ${dev}hci: l2cap acl hci \
+		> /dev/null 2>&1 || return 1
+
+	ngctl name ${dev}hci:acl ${dev}l2cap \
+		> /dev/null 2>&1 || return 1
+
+	ngctl msg ${dev}l2cap: set_debug ${bluetooth_device_l2cap_debug_level} \
+		> /dev/null 2>&1 || return 1
+
+	# Connect HCI node to the Bluetooth sockets layer
+	ngctl connect ${dev}hci: btsock_hci_raw: raw ${dev}raw \
+		> /dev/null 2>&1 || return 1
+
+	# Connect L2CAP node to Bluetooth sockets layer
+	ngctl connect ${dev}l2cap: btsock_l2c_raw: ctl ${dev}ctl \
+		> /dev/null 2>&1 || return 1
+
+	ngctl connect ${dev}l2cap: btsock_l2c: l2c ${dev}l2c \
+		> /dev/null 2>&1 || return 1
+
+	# Initialize HCI node
+	${hccontrol} -n ${dev}hci reset \
+		> /dev/null 2>&1 || return 1
+
+	${hccontrol} -n ${dev}hci read_bd_addr \
+		> /dev/null 2>&1 || return 1
+
+	${hccontrol} -n ${dev}hci read_local_supported_features \
+		> /dev/null 2>&1 || return 1
+
+	${hccontrol} -n ${dev}hci read_buffer_size \
+		> /dev/null 2>&1 || return 1
+
+	if checkyesno bluetooth_device_discoverable; then
+		if checkyesno bluetooth_device_connectable; then
+			${hccontrol} -n ${dev}hci write_scan_enable 3 \
+				> /dev/null 2>&1 || return 1
+		else
+			${hccontrol} -n ${dev}hci write_scan_enable 1 \
+				> /dev/null 2>&1 || return 1
+		fi
+	else
+		if checkyesno bluetooth_device_connectable; then
+			${hccontrol} -n ${dev}hci write_scan_enable 2 \
+				> /dev/null 2>&1 || return 1
+		else
+			${hccontrol} -n ${dev}hci write_scan_enable 0 \
+				> /dev/null 2>&1 || return 1
+		fi
+	fi
+
+
+	${hccontrol} -n ${dev}hci write_class_of_device ${bluetooth_device_class} \
+		> /dev/null 2>&1 || return 1
+
+	if checkyesno bluetooth_device_authentication_enable; then
+		${hccontrol} -n ${dev}hci write_authentication_enable 1 \
+			> /dev/null 2>&1 || return 1
+	else
+		${hccontrol} -n ${dev}hci write_authentication_enable 0 \
+			> /dev/null 2>&1 || return 1
+	fi
+
+	case "${bluetooth_device_encryption_mode}" in
+	[Nn][Oo][Nn][Ee]|0)
+		${hccontrol} -n ${dev}hci write_encryption_mode 0 \
+			> /dev/null 2>&1 || return 1
+		;;
+
+	[Pp][2][Pp]|1)
+		${hccontrol} -n ${dev}hci write_encryption_mode 1 \
+			> /dev/null 2>&1 || return 1
+		;;
+
+	[Al][Ll][Ll]|2)
+		${hccontrol} -n ${dev}hci write_encryption_mode 2 \
+			> /dev/null 2>&1 || return 1
+		;;
+
+	*)
+		warn "Unsupported encryption mode ${bluetooth_device_encryption_mode} for device ${dev}"
+		return 1
+		;;
+	esac
+
+	if checkyesno bluetooth_device_role_switch; then
+		${hccontrol} -n ${dev}hci write_node_role_switch 1 \
+			> /dev/null 2>&1 || return 1
+	else
+		${hccontrol} -n ${dev}hci write_node_role_switch 0 \
+			> /dev/null 2>&1 || return 1
+	fi
+
+	${hccontrol} -n ${dev}hci change_local_name "${bluetooth_device_local_name}" \
+		> /dev/null 2>&1 || return 1
+
+	${hccontrol} -n ${dev}hci initialize \
+		> /dev/null 2>&1 || return 1
+
+	return 0
+}
+
+##############################################################################
+# Shutdown Bluetooth stack. Destroy all nodes
+##############################################################################
+
+bluetooth_shutdown_stack()
+{
+	dev=$1
+
+	ngctl shutdown ${dev}hci: > /dev/null 2>&1
+	ngctl shutdown ${dev}l2cap: > /dev/null 2>&1
+
+	return 0
+}
+
+##############################################################################
+# bluetooth_start()
+##############################################################################
+
+bluetooth_start()
+{
+	local _file
+
+	dev=$1
+
+	# Try to figure out device type by looking at device name
+	case "${dev}" in
+	# uartX - serial/UART Bluetooth device
+	uart*)
+		load_kld ng_h4 || return 1
+
+		hook="hook"
+
+		# Obtain unit number from device.
+		unit=`expr ${dev} : 'uart\([0-9]\{1,\}\)'`
+		if [ -z "${unit}" ]; then
+			err 1 "Unable to get uart unit number: ${dev}"
+		fi
+
+		${hcseriald} -f /dev/cuau${unit} -n ${dev}
+		sleep 1 # wait a little bit
+
+		if [ ! -f "/var/run/hcseriald.${dev}.pid" ]; then
+			err 1 "Unable to start hcseriald on ${dev}"
+		fi
+		;;
+
+	# 3Com Bluetooth Adapter 3CRWB60-A
+	btccc*)
+		hook="hook"
+
+		# Obtain unit number from device.
+		unit=`expr ${dev} : 'btccc\([0-9]\{1,\}\)'`
+		if [ -z "${unit}" ]; then
+			err 1 "Unable to get bt3c unit number: ${dev}"
+		fi
+		;;
+
+	# USB Bluetooth adapters
+	ubt*)
+		hook="hook"
+
+		# Obtain unit number from device.
+		unit=`expr ${dev} : 'ubt\([0-9]\{1,\}\)'`
+		if [ -z "${unit}" ]; then
+			err 1 "Unable to get ubt unit number: ${dev}"
+		fi
+		;;
+
+	# Unknown
+	*)
+		err 1 "Unsupported device: ${dev}"
+		;;
+	esac
+
+	# Be backward compatible and setup reasonable defaults
+	bluetooth_device_authentication_enable="0"
+	bluetooth_device_class="ff:01:0c"
+	bluetooth_device_connectable="1"
+	bluetooth_device_discoverable="1"
+	bluetooth_device_encryption_mode="0"
+	bluetooth_device_hci_debug_level="3"
+	bluetooth_device_l2cap_debug_level="3"
+	bluetooth_device_local_name="`/usr/bin/uname -n` (${dev})"
+	bluetooth_device_role_switch="1"
+
+	# Load default device configuration parameters
+	_file="/etc/defaults/bluetooth.device.conf"
+
+	if ! bluetooth_read_conf $_file bluetooth_device_ ; then
+		err 1 "Unable to read default Bluetooth configuration from $_file"
+	fi
+
+	# Load device specific overrides
+	_file="/etc/bluetooth/$dev.conf"
+
+	if ! bluetooth_read_conf $_file bluetooth_device_ ; then
+		err 1 "Unable to read Bluetooth device configuration from $_file"
+	fi
+
+	# Setup stack
+	if ! bluetooth_setup_stack ${dev} ${hook} ; then
+		bluetooth_shutdown_stack $dev
+		err 1 "Unable to setup Bluetooth stack for device ${dev}"
+	fi
+
+	return 0
+}
+
+##############################################################################
+# bluetooth_stop()
+##############################################################################
+
+bluetooth_stop()
+{
+	dev=$1
+
+	# Try to figure out device type by looking at device name
+	case "${dev}" in
+	# uartX - serial/UART Bluetooth device
+	uart*)
+		if [ -f "/var/run/hcseriald.${dev}.pid" ]; then
+			kill `cat /var/run/hcseriald.${dev}.pid`
+			sleep 1 # wait a little bit
+		fi
+		;;
+
+	# 3Com Bluetooth Adapter 3CRWB60-A
+	btccc*)
+		;;
+
+	# USB Bluetooth adapters
+	ubt*)
+		;;
+
+	# Unknown
+	*)
+		err 1 "Unsupported device: ${dev}"
+		;;
+	esac
+
+	bluetooth_shutdown_stack ${dev}
+
+	return 0
+}
+
+##############################################################################
+# Start here
+##############################################################################
+
+load_rc_config $name
+hccontrol="${bluetooth_hccontrol:-/usr/sbin/hccontrol}"
+hcseriald="${bluetooth_hcseriald:-/usr/sbin/hcseriald}"
+
+run_rc_command $*
+
diff --git a/etc/rc.d/bthidd b/etc/rc.d/bthidd
new file mode 100644
index 0000000000..1a1a59fca8
--- /dev/null
+++ b/etc/rc.d/bthidd
@@ -0,0 +1,33 @@
+#!/bin/sh
+#
+# $FreeBSD: head/etc/rc.d/bthidd 230099 2012-01-14 02:18:41Z dougb $
+#
+
+# PROVIDE: bthidd
+# REQUIRE: DAEMON hcsecd
+# BEFORE: LOGIN
+# KEYWORD: nojail shutdown
+
+. /etc/rc.subr
+
+name="bthidd"
+rcvar="bthidd_enable"
+command="/usr/sbin/${name}"
+pidfile="/var/run/${name}.pid"
+start_precmd="bthidd_prestart"
+
+bthidd_prestart()
+{
+	load_kld -m kbdmux kbdmux
+	load_kld -m vkbd vkbd
+	load_kld -m ng_btsocket ng_btsocket
+	return 0
+}
+
+load_rc_config $name
+config="${bthidd_config:-/etc/bluetooth/${name}.conf}"
+hids="${bthidd_hids:-/var/db/${name}.hids}"
+command_args="-c ${config} -H ${hids} -p ${pidfile}"
+required_files="${config}"
+
+run_rc_command "$1"
diff --git a/etc/rc.d/hcsecd b/etc/rc.d/hcsecd
new file mode 100644
index 0000000000..6bcba53c5d
--- /dev/null
+++ b/etc/rc.d/hcsecd
@@ -0,0 +1,24 @@
+#!/bin/sh
+#
+# $FreeBSD: head/etc/rc.d/hcsecd 230099 2012-01-14 02:18:41Z dougb $
+#
+
+# PROVIDE: hcsecd
+# REQUIRE: DAEMON
+# BEFORE: LOGIN
+# KEYWORD: nojail shutdown
+
+. /etc/rc.subr
+
+name="hcsecd"
+rcvar="hcsecd_enable"
+command="/usr/sbin/${name}"
+pidfile="/var/run/${name}.pid"
+required_modules="ng_btsocket"
+
+load_rc_config $name
+config="${hcsecd_config:-/etc/bluetooth/${name}.conf}"
+command_args="-f ${config}"
+required_files="${config}"
+
+run_rc_command "$1"
diff --git a/etc/rc.d/sdpd b/etc/rc.d/sdpd
index 40d28a72f3..2d4ec7c72a 100644
--- a/etc/rc.d/sdpd
+++ b/etc/rc.d/sdpd
@@ -1,17 +1,24 @@
 #!/bin/sh
 #
-# $NetBSD: sdpd,v 1.2 2007/03/18 15:53:54 plunky Exp $
+# $FreeBSD: head/etc/rc.d/sdpd 230099 2012-01-14 02:18:41Z dougb $
 #
 
 # PROVIDE: sdpd
-# REQUIRE: bluetooth
+# REQUIRE: DAEMON
 # BEFORE: LOGIN
+# KEYWORD: nojail shutdown
 
 . /etc/rc.subr
 
 name="sdpd"
-rcvar=$name
 command="/usr/sbin/${name}"
+rcvar="sdpd_enable"
+required_modules="ng_btsocket"
 
 load_rc_config $name
+control="${sdpd_control:-/var/run/sdp}"
+group="${sdpd_groupname:-nobody}"
+user="${sdpd_username:-nobody}"
+command_args="-c ${control} -g ${group} -u ${user}"
+
 run_rc_command "$1"
diff --git a/etc/rc.d/ubthidhci b/etc/rc.d/ubthidhci
new file mode 100644
index 0000000000..b5782132d2
--- /dev/null
+++ b/etc/rc.d/ubthidhci
@@ -0,0 +1,40 @@
+#!/bin/sh
+#
+# $FreeBSD: head/etc/rc.d/ubthidhci 230099 2012-01-14 02:18:41Z dougb $
+#
+
+# PROVIDE: ubthidhci
+# REQUIRE: DAEMON
+# BEFORE: bluetooth
+# KEYWORD: nojail shutdown
+
+. /etc/rc.subr
+
+name="ubthidhci"
+rcvar="ubthidhci_enable"
+command="/usr/sbin/usbconfig"
+start_precmd="ubthidhci_prestart"
+
+ubthidhci_prestart()
+{
+
+	if [ -z ${ubthidhci_busnum} ]; then
+		warn ubthidhci_busnum is not set
+		return 1
+	fi
+	if [ -z ${ubthidhci_addr} ]; then
+		warn ubthidhci_addr is not set
+		return 1
+	fi
+}
+
+load_rc_config $name
+#
+# We discard the output because:
+# 1) we don't want it to show up during boot; and
+# 2) the request usually returns an error, but that doesn't mean it failed
+#
+# NB: 0x40 is UT_VENDOR
+command_args="-u ${ubthidhci_busnum} -a ${ubthidhci_addr} do_request 0x40 0 0 0 0 > /dev/null 2>&1"
+
+run_rc_command "$1"
diff --git a/include/Makefile b/include/Makefile
index 0abb644089..44f47e93e9 100644
--- a/include/Makefile
+++ b/include/Makefile
@@ -43,7 +43,7 @@ LHDRS=	aio.h errno.h fcntl.h linker_set.h poll.h sched.h syslog.h ucontext.h
 # Other directories, like 'bus' and 'netproto', are created using mtree.
 #
 # XXX allow these directories to not contain header files.
-LDIRS=	net netbt netgraph netgraph7 netinet netinet6 sys vm
+LDIRS=	net netgraph netgraph7 netinet netinet6 sys vm
 
 # Subdirectories containing header files to copy.  In symlink mode
 # the subdirectory will be symlinked.  Care must be taken to adjust
@@ -76,7 +76,8 @@ LSUBDIRS= \
 	netgraph/mppc netgraph/one2many netgraph/ppp \
 	netgraph/pppoe netgraph/pptpgre netgraph/rfc1490 netgraph/socket \
 	netgraph/tee netgraph/tty netgraph/vjc \
-	netgraph7/UI netgraph7/async netgraph7/bpf \
+	netgraph7/UI netgraph7/async \
+	netgraph7/bluetooth/include netgraph7/bpf \
 	netgraph7/bridge netgraph7/cisco netgraph7/deflate netgraph7/echo \
 	netgraph7/eiface netgraph7/etf netgraph7/ether \
 	netgraph7/frame_relay netgraph7/hole netgraph7/hub \
diff --git a/lib/libbluetooth/Makefile b/lib/libbluetooth/Makefile
index 9538cc9865..a34fb531a2 100644
--- a/lib/libbluetooth/Makefile
+++ b/lib/libbluetooth/Makefile
@@ -1,16 +1,16 @@
-# $NetBSD: Makefile,v 1.3 2007/05/28 12:06:18 tls Exp $
-
-SYSDIR= ${.CURDIR}/../../sys/
+# $Id: Makefile,v 1.5 2003/07/22 18:38:04 max Exp $
+# $FreeBSD: head/lib/libbluetooth/Makefile 195767 2009-07-19 17:25:24Z kensmith $
 
 LIB=		bluetooth
-SHLIB_MAJOR=	3
-SRCS=		bluetooth.c devaddr.c
 MAN=		bluetooth.3
 
-CFLAGS+=	-I${.CURDIR} -I${SYSDIR}
+WARNS?=		2
+CFLAGS+=	-I${.CURDIR} -I${.CURDIR}/../../sys
+
+SHLIB_MAJOR=	4
 
+SRCS=		bluetooth.c dev.c hci.c
 INCS=		bluetooth.h
-INCSDIR=	/usr/include
 
 MLINKS+=	bluetooth.3 bt_gethostbyname.3
 MLINKS+=	bluetooth.3 bt_gethostbyaddr.3
@@ -30,6 +30,24 @@ MLINKS+=	bluetooth.3 bt_aton.3
 MLINKS+=	bluetooth.3 bt_devaddr.3
 MLINKS+=	bluetooth.3 bt_devname.3
 
-CFLAGS+=	-I${.CURDIR} -I${SYSDIR}
+MLINKS+=	bluetooth.3 bt_devinfo.3
+MLINKS+=	bluetooth.3 bt_devenum.3
+
+MLINKS+=	bluetooth.3 bt_devopen.3
+MLINKS+=	bluetooth.3 bt_devclose.3
+MLINKS+=	bluetooth.3 bt_devsend.3
+MLINKS+=	bluetooth.3 bt_devreq.3
+MLINKS+=	bluetooth.3 bt_devfilter.3
+MLINKS+=	bluetooth.3 bt_devfilter_pkt_set.3
+MLINKS+=	bluetooth.3 bt_devfilter_pkt_clr.3
+MLINKS+=	bluetooth.3 bt_devfilter_pkt_tst.3
+MLINKS+=	bluetooth.3 bt_devfilter_evt_set.3
+MLINKS+=	bluetooth.3 bt_devfilter_evt_clr.3
+MLINKS+=	bluetooth.3 bt_devfilter_evt_tst.3
+MLINKS+=	bluetooth.3 bt_devinquiry.3
+
+MLINKS+=	bluetooth.3 bdaddr_same.3
+MLINKS+=	bluetooth.3 bdaddr_any.3
+MLINKS+=	bluetooth.3 bdaddr_copy.3
 
 .include <bsd.lib.mk>
diff --git a/lib/libbluetooth/bluetooth.c b/lib/libbluetooth/bluetooth.c
index ba1efb16a5..93113eb8d3 100644
--- a/lib/libbluetooth/bluetooth.c
+++ b/lib/libbluetooth/bluetooth.c
@@ -1,9 +1,9 @@
-/* $NetBSD: bluetooth.c,v 1.1 2006/06/19 15:44:36 gdamore Exp $ */
-
 /*
  * bluetooth.c
- *
- * Copyright (c) 2001-2003 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ */
+
+/*-
+ * Copyright (c) 2001-2009 Maksim Yevmenkin <m_evmenkin@yahoo.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -27,8 +27,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: bluetooth.c,v 1.1 2006/06/19 15:44:36 gdamore Exp $
- * $FreeBSD: src/lib/libbluetooth/bluetooth.c,v 1.2 2004/03/05 08:10:17 markm Exp $
+ * $Id: bluetooth.c,v 1.3 2003/05/20 23:04:30 max Exp $
+ * $FreeBSD: head/lib/libbluetooth/bluetooth.c 189462 2009-03-06 23:30:07Z emax $
  */
 
 #include <bluetooth.h>
@@ -67,7 +67,7 @@ bt_gethostbyname(char const *name)
 	while ((p = bt_gethostent()) != NULL) {
 		if (strcasecmp(p->h_name, name) == 0)
 			break;
-		for (cp = p->h_aliases; *cp != NULL; cp++)
+		for (cp = p->h_aliases; *cp != 0; cp++)
 			if (strcasecmp(*cp, name) == 0)
 				goto found;
 	}
@@ -78,7 +78,7 @@ bt_gethostbyname(char const *name)
 }
 
 struct hostent *
-bt_gethostbyaddr(void const *addr, socklen_t len, int type)
+bt_gethostbyaddr(char const *addr, int len, int type)
 {
 	struct hostent	*p;
 
@@ -89,7 +89,7 @@ bt_gethostbyaddr(void const *addr, socklen_t len, int type)
 
 	bt_sethostent(host_stayopen);
 	while ((p = bt_gethostent()) != NULL)
-		if (p->h_addrtype == type && memcmp(p->h_addr, addr, len) == 0)
+		if (p->h_addrtype == type && bcmp(p->h_addr, addr, len) == 0)
 			break;
 	bt_endhostent();
 
@@ -121,7 +121,7 @@ bt_gethostent(void)
 	if ((cp = strpbrk(p, " \t")) == NULL)
 		goto again;
 	*cp++ = 0;
-	if (bt_aton(p, &host_addr) == 0)
+	if (bt_aton(p, &host_addr) == 0) 
 		goto again;
 	host_addr_ptrs[0] = (char *) &host_addr;
 	host_addr_ptrs[1] = NULL;
@@ -180,7 +180,7 @@ bt_getprotobyname(char const *name)
 	while ((p = bt_getprotoent()) != NULL) {
 		if (strcmp(p->p_name, name) == 0)
 			break;
-		for (cp = p->p_aliases; *cp != NULL; cp++)
+		for (cp = p->p_aliases; *cp != 0; cp++)
 			if (strcmp(*cp, name) == 0)
 				goto found;
 	}
@@ -191,13 +191,13 @@ bt_getprotobyname(char const *name)
 }
 
 struct protoent *
-bt_getprotobynumber(int num)
+bt_getprotobynumber(int proto)
 {
 	struct protoent	*p;
 
 	bt_setprotoent(proto_stayopen);
 	while ((p = bt_getprotoent()) != NULL)
-		if (p->p_proto == num)
+		if (p->p_proto == proto)
 			break;
 	bt_endprotoent();
 
@@ -230,7 +230,7 @@ bt_getprotoent(void)
 		cp++;
 	if ((p = strpbrk(cp, " \t")) != NULL)
 		*p++ = '\0';
-	proto.p_proto = (int)strtol(cp, NULL, 0);
+	proto.p_proto = atoi(cp);
 	q = proto.p_aliases = proto_aliases;
 	if (p != NULL) {
 		cp = p;
@@ -308,7 +308,7 @@ bt_aton(char const *str, bdaddr_t *ba)
 			b = -1;
 			break;
 		}
-
+		
 		if (b < 0)
 			return (0);
 
@@ -368,3 +368,4 @@ bt_hex_nibble(char nibble)
 
 	return (-1);
 }
+
diff --git a/lib/libbluetooth/bluetooth.h b/lib/libbluetooth/bluetooth.h
index baadadb43f..33c6202bd4 100644
--- a/lib/libbluetooth/bluetooth.h
+++ b/lib/libbluetooth/bluetooth.h
@@ -1,10 +1,9 @@
-/* $NetBSD: bluetooth.h,v 1.3 2006/09/26 19:18:19 plunky Exp $ */
-/* $DragonFly: src/lib/libbluetooth/bluetooth.h,v 1.1 2008/01/03 11:47:52 hasso Exp $ */
-
 /*
  * bluetooth.h
- *
- * Copyright (c) 2001-2003 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ */
+
+/*-
+ * Copyright (c) 2001-2009 Maksim Yevmenkin <m_evmenkin@yahoo.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -28,88 +27,190 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: bluetooth.h,v 1.3 2006/09/26 19:18:19 plunky Exp $
- * $FreeBSD: src/lib/libbluetooth/bluetooth.h,v 1.2 2005/03/17 21:39:44 emax Exp $
+ * $Id: bluetooth.h,v 1.5 2003/09/14 23:28:42 max Exp $
+ * $FreeBSD: head/lib/libbluetooth/bluetooth.h 213042 2010-09-22 23:41:02Z emax $
  */
 
 #ifndef _BLUETOOTH_H_
 #define _BLUETOOTH_H_
 
 #include <sys/types.h>
+#include <bitstring.h>		/* XXX */
 #include <sys/endian.h>
+#include <sys/ioctl.h>
 #include <sys/socket.h>
+#include <sys/uio.h>
+#include <sys/un.h>
+#include <errno.h>
 #include <netdb.h>
-#include <netbt/bluetooth.h>
-#include <netbt/hci.h>
-#include <netbt/l2cap.h>
-#include <stdio.h>
+#include <netgraph7/ng_message.h>
+#include <netgraph7/bluetooth/include/ng_hci.h>
+#include <netgraph7/bluetooth/include/ng_l2cap.h>
+#include <netgraph7/bluetooth/include/ng_btsocket.h>
+#include <time.h>
 
 __BEGIN_DECLS
 
+/*
+ * Linux BlueZ compatibility
+ */
+
+#define	bacmp(ba1, ba2)	memcmp((ba1), (ba2), sizeof(bdaddr_t))
+#define	bacpy(dst, src)	memcpy((dst), (src), sizeof(bdaddr_t))
+#define ba2str(ba, str)	bt_ntoa((ba), (str))
+#define str2ba(str, ba)	(bt_aton((str), (ba)) == 1? 0 : -1)
+#define htobs(d)	htole16(d)
+#define htobl(d)	htole32(d)
+#define btohs(d)	le16toh(d)
+#define btohl(d)	le32toh(d)
+
 /*
  * Interface to the outside world
  */
 
-struct hostent *  bt_gethostbyname    (char const *);
-struct hostent *  bt_gethostbyaddr    (void const *, socklen_t, int);
+struct hostent *  bt_gethostbyname    (char const *name);
+struct hostent *  bt_gethostbyaddr    (char const *addr, int len, int type);
 struct hostent *  bt_gethostent       (void);
-void              bt_sethostent       (int);
+void              bt_sethostent       (int stayopen);
 void              bt_endhostent       (void);
 
-struct protoent * bt_getprotobyname   (char const *);
-struct protoent * bt_getprotobynumber (int);
+struct protoent * bt_getprotobyname   (char const *name);
+struct protoent * bt_getprotobynumber (int proto);
 struct protoent * bt_getprotoent      (void);
-void              bt_setprotoent      (int);
+void              bt_setprotoent      (int stayopen);
 void              bt_endprotoent      (void);
 
-char const *      bt_ntoa             (bdaddr_t const *, char *);
-int               bt_aton             (char const *, bdaddr_t *);
+char const *      bt_ntoa             (bdaddr_t const *ba, char *str);
+int               bt_aton             (char const *str, bdaddr_t *ba);
 
-int               bt_devaddr          (const char *, bdaddr_t *);
-int               bt_devname          (char *, const bdaddr_t *);
+/* bt_devXXXX() functions (inspired by NetBSD) */
+int               bt_devaddr          (char const *devname, bdaddr_t *addr);
+int               bt_devname          (char *devname, bdaddr_t const *addr);
 
-/*
- * bthcid(8) PIN Client API
+/* 
+ * Bluetooth HCI functions
  */
 
-/* Client PIN Request packet */
-typedef struct {
-	bdaddr_t	laddr;			/* local address */
-	bdaddr_t	raddr;			/* remote address */
-	uint8_t		time;			/* validity (seconds) */
-} __attribute__ ((packed)) bthcid_pin_request_t;
-
-/* Client PIN Response packet */
-typedef struct {
-	bdaddr_t	laddr;			/* local address */
-	bdaddr_t	raddr;			/* remote address */
-	uint8_t		pin[HCI_PIN_SIZE];	/* PIN */
-} __attribute__ ((packed)) bthcid_pin_response_t;
-
-/* Default socket name */
-#define BTHCID_SOCKET_NAME	"/var/run/bthcid"
-
-#define COMPAT_BLUEZ 
-#ifdef COMPAT_BLUEZ
+#define	HCI_DEVMAX			32		/* arbitrary */
+#define	HCI_DEVNAME_SIZE		NG_NODESIZ
+#define	HCI_DEVFEATURES_SIZE		NG_HCI_FEATURES_SIZE
+
+struct bt_devinfo
+{
+	char		devname[HCI_DEVNAME_SIZE];
+
+	uint32_t	state;		/* device/implementation specific */
+
+	bdaddr_t	bdaddr;
+	uint16_t	_reserved0;
+
+	uint8_t		features[HCI_DEVFEATURES_SIZE];
+
+	/* buffer info */
+	uint16_t	_reserved1;
+	uint16_t	cmd_free;
+	uint16_t	sco_size;
+	uint16_t	sco_pkts;
+	uint16_t	sco_free;
+	uint16_t	acl_size;
+	uint16_t	acl_pkts;
+	uint16_t	acl_free;
+
+	/* stats */
+	uint32_t	cmd_sent;
+	uint32_t	evnt_recv;
+	uint32_t	acl_recv;
+	uint32_t	acl_sent;
+	uint32_t	sco_recv;
+	uint32_t	sco_sent;
+	uint32_t	bytes_recv;
+	uint32_t	bytes_sent;
+
+	/* misc/specific */
+	uint16_t	link_policy_info;
+	uint16_t	packet_type_info;
+	uint16_t	role_switch_info;
+	uint16_t	debug;
+
+	uint8_t		_padding[20];	/* leave space for future additions */
+};
+
+struct bt_devreq
+{
+	uint16_t	opcode;
+	uint8_t		event;
+	void		*cparam;
+	size_t		clen;
+	void		*rparam;
+	size_t		rlen;
+};
+
+struct bt_devfilter {
+	bitstr_t	bit_decl(packet_mask, 8);
+	bitstr_t	bit_decl(event_mask, 256);
+};
+
+struct bt_devinquiry {
+	bdaddr_t        bdaddr;
+	uint8_t         pscan_rep_mode;
+	uint8_t         pscan_period_mode;
+	uint8_t         dev_class[3];
+	uint16_t        clock_offset;
+	int8_t          rssi;
+	uint8_t         data[240];
+};
+
+typedef int	(bt_devenum_cb_t)(int, struct bt_devinfo const *, void *);
+
+int		bt_devopen (char const *devname);
+int		bt_devclose(int s);
+int		bt_devsend (int s, uint16_t opcode, void *param, size_t plen);
+ssize_t		bt_devrecv (int s, void *buf, size_t size, time_t to);
+int		bt_devreq  (int s, struct bt_devreq *r, time_t to);
+int		bt_devfilter(int s, struct bt_devfilter const *newp,
+			     struct bt_devfilter *oldp);
+void		bt_devfilter_pkt_set(struct bt_devfilter *filter, uint8_t type);
+void		bt_devfilter_pkt_clr(struct bt_devfilter *filter, uint8_t type);
+int		bt_devfilter_pkt_tst(struct bt_devfilter const *filter, uint8_t type);
+void		bt_devfilter_evt_set(struct bt_devfilter *filter, uint8_t event);
+void		bt_devfilter_evt_clr(struct bt_devfilter *filter, uint8_t event);
+int		bt_devfilter_evt_tst(struct bt_devfilter const *filter, uint8_t event);
+int		bt_devinquiry(char const *devname, time_t length, int num_rsp,
+			      struct bt_devinquiry **ii);
+int		bt_devinfo (struct bt_devinfo *di);
+int		bt_devenum (bt_devenum_cb_t *cb, void *arg);
+
 /*
- * Linux BlueZ compatibility
+ * bdaddr utility functions (from NetBSD)
  */
 
-#define	bacmp(ba1, ba2)	memcmp((ba1), (ba2), sizeof(bdaddr_t))
-#define	bacpy(dst, src)	memcpy((dst), (src), sizeof(bdaddr_t))
-#define ba2str(ba, str)	bt_ntoa((ba), (str))
-#define str2ba(str, ba)	(bt_aton((str), (ba)) == 1 ? 0 : -1)
-
-#define htobs(x)	htole16(x)
-#define htobl(x)	htole32(x)
-#define btohs(x)	le16toh(x)
-#define btohl(x)	le32toh(x)
-
-#define bt_malloc(n)	malloc(n)
-#define bt_free(p)	free(p)
-
-#endif	/* COMPAT_BLUEZ */
+static __inline int
+bdaddr_same(const bdaddr_t *a, const bdaddr_t *b)
+{
+	return (a->b[0] == b->b[0] && a->b[1] == b->b[1] &&
+		a->b[2] == b->b[2] && a->b[3] == b->b[3] &&
+		a->b[4] == b->b[4] && a->b[5] == b->b[5]);
+}
+
+static __inline int
+bdaddr_any(const bdaddr_t *a)
+{
+	return (a->b[0] == 0 && a->b[1] == 0 && a->b[2] == 0 &&
+		a->b[3] == 0 && a->b[4] == 0 && a->b[5] == 0);
+}
+
+static __inline void
+bdaddr_copy(bdaddr_t *d, const bdaddr_t *s)
+{
+	d->b[0] = s->b[0];
+	d->b[1] = s->b[1];
+	d->b[2] = s->b[2];
+	d->b[3] = s->b[3];
+	d->b[4] = s->b[4];
+	d->b[5] = s->b[5];
+}
 
 __END_DECLS
 
 #endif /* ndef _BLUETOOTH_H_ */
+
